import { ref as g, computed as A, onUnmounted as B, watch as K } from "vue";
import * as R from "pdfjs-dist";
function z(v) {
  const n = v.split(","), i = n[0].match(/:(.*?);/)[1], u = atob(n[1]), r = u.length, d = new Uint8Array(r);
  let s = r;
  for (; s--; )
    d[s] = u.charCodeAt(s);
  return new Blob([d], { type: i });
}
function G(v) {
  let n = null;
  return window.URL !== void 0 ? n = window.URL.createObjectURL(v) : window.webkitURL !== void 0 && (n = window.webkitURL.createObjectURL(v)), n;
}
const U = {
  scale: 2,
  quality: 1,
  type: "image/png",
  maxCachePages: 10,
  preloadCount: 1,
  retryCount: 3,
  retryDelay: 1e3,
  adaptiveScale: !1
};
function V() {
  const v = g(!1), n = g(1), i = g(0), u = g(null), r = g([]), d = g(/* @__PURE__ */ new Set()), s = g({ ...U });
  R.GlobalWorkerOptions.workerSrc = "/libs/pdfjs@3.9.179/pdf.worker.min.js";
  const x = () => {
    const e = navigator.deviceMemory || 4, a = navigator.hardwareConcurrency || 4;
    return Math.min(1.5, Math.max(0.5, e / 4 * (a / 4)));
  }, j = (e = {}) => {
    const a = { ...U, ...e };
    if (a.adaptiveScale) {
      const t = x(), o = a.scale !== void 0 ? a.scale : U.scale;
      if (a.scale = o * t, t < 0.8) {
        const c = a.quality !== void 0 ? a.quality : 1;
        a.quality = Math.min(c, 0.8);
      }
    }
    console.log(a), s.value = a;
  }, b = async (e, a = {}) => {
    try {
      if (v.value = !0, !R)
        throw new Error("PDF.js library not found");
      j(a);
      let t = s.value.retryCount || 3, o = null;
      for (; t > 0; )
        try {
          u.value = await R.getDocument({
            url: e,
            cMapPacked: !0,
            cMapUrl: "/api/drawing/plugins/preview/pdflib/cmaps/"
          }).promise, i.value = u.value.numPages, n.value = 1, r.value = Array.from({ length: i.value }), await w(1), p(1);
          return;
        } catch (c) {
          o = c, t--, t > 0 && (console.warn(`PDF加载失败，剩余重试次数: ${t}`), await new Promise((l) => setTimeout(l, s.value.retryDelay || 1e3)));
        }
      throw console.error("PDF加载失败，已达到最大重试次数:", o), o;
    } catch (t) {
      throw console.error("Error loading PDF:", t), t;
    } finally {
      v.value = !1;
    }
  }, p = async (e) => {
    const a = s.value.preloadCount || 1;
    for (let t = 1; t <= a; t++) {
      const o = e + t;
      o <= i.value && !r.value[o - 1] && setTimeout(() => {
        w(o).catch((c) => {
          console.warn(`Preload page ${o} failed:`, c);
        });
      }, t * 100);
    }
    for (let t = 1; t <= Math.min(1, a); t++) {
      const o = e - t;
      o > 0 && !r.value[o - 1] && setTimeout(() => {
        w(o).catch((c) => {
          console.warn(`Preload page ${o} failed:`, c);
        });
      }, (a + t) * 100);
    }
  }, O = (e) => {
    const a = s.value.maxCachePages || 10;
    if (i.value <= a) return;
    const t = Math.floor(a / 2), o = Math.max(1, e - t), c = Math.min(i.value, e + t);
    for (let l = 0; l < i.value; l++) {
      const f = l + 1;
      (f < o || f > c) && r.value[l] && (URL.revokeObjectURL(r.value[l]), r.value = [...r.value.slice(0, l), "", ...r.value.slice(l + 1)]);
    }
  }, w = async (e, a = {}) => {
    const { currentRetry: t = 0 } = a, o = s.value.retryCount || 3, c = s.value.retryDelay || 1e3;
    try {
      if (d.value.has(e))
        return new Promise(($) => {
          const q = setInterval(() => {
            !d.value.has(e) && r.value[e - 1] && (clearInterval(q), $(r.value[e - 1]));
          }, 100);
        });
      if (!u.value)
        throw new Error("No PDF document loaded");
      if (r.value[e - 1])
        return r.value[e - 1];
      d.value.add(e);
      const { scale: l = 3.5, quality: f = 1, type: h = "image/jpeg" } = s.value, m = await u.value.getPage(e), P = m.getViewport({ scale: l }), y = document.createElement("canvas"), L = y.getContext("2d");
      if (!L)
        throw new Error("Cannot get canvas context");
      y.width = P.width, y.height = P.height;
      const T = {
        canvasContext: L,
        viewport: P
      };
      await m.render(T).promise;
      const S = y.toDataURL(h, f), I = z(S), C = G(I);
      return C && (r.value = [...r.value.slice(0, e - 1), C, ...r.value.slice(e)]), d.value.delete(e), C;
    } catch (l) {
      if (d.value.delete(e), t < o)
        return console.warn(`Rendering page ${e} failed, retrying (${t + 1}/${o})...`, l), new Promise((f, h) => {
          setTimeout(() => {
            w(e, { currentRetry: t + 1 }).then(f).catch(h);
          }, c);
        });
      throw console.error("Error rendering page after retries:", l), l;
    }
  }, E = async (e = {}) => {
    if (!u.value)
      throw new Error("No PDF document loaded");
    const a = { ...s.value, ...e };
    s.value = a;
    const t = [], o = 3;
    for (let c = 0; c < i.value; c += o) {
      const l = [];
      for (let h = 0; h < o && c + h < i.value; h++) {
        const m = c + h + 1;
        l.push(w(m));
      }
      const f = await Promise.all(l);
      t.push(...f);
    }
    return t;
  }, M = A(() => r.value[n.value - 1]), D = () => {
    r.value.forEach((e) => {
      e && URL.revokeObjectURL(e);
    }), r.value = [], u.value = null, i.value = 0, n.value = 1;
  };
  B(D);
  const k = async () => (n.value < i.value && (n.value++, p(n.value)), n.value), F = async () => (n.value > 1 && (n.value--, p(n.value)), n.value);
  return K(n, (e, a) => {
    e !== a && (w(e), O(e));
  }), {
    imageCache: r,
    isLoading: v,
    currentPage: n,
    totalPages: i,
    loadPdfFile: b,
    currentImageUrl: M,
    renderPageToImage: w,
    convertAllPages: E,
    nextPage: k,
    // 导出下一页函数
    prevPage: F,
    // 导出上一页函数
    cleanup: D
  };
}
export {
  z as dataURLtoBlob,
  G as getObjectURL,
  V as usePdf2img
};
